name = mfp.programName.rsplit(".",1)[-1]
module = mfp.dofile(mfp.p(mfpl.sd,"module.py"))
addon = mfp.dofile(mfp.p(mfpl.sd,"addon.py"))
windows = []

import gi
gi.require_version("Gtk","3.0")
gi.require_version("WebKit2","4.0")
from gi.repository import Gtk,WebKit2
import sys

destroyedViews = []

def unrefWebView(webView): # yeaah, this actually references a webView just... yes.
	destroyedViews.append(webView) # not keeping a reference makes gtk sad.. i should probably report this.
	if len(destroyedViews) > 100: destroyedViews.pop(0)

def createWebView(*args,relatedWebView = None,webView = None,**kwargs):
	if webView == None:
		if relatedWebView != None:
			webView = WebKit2.WebView.new_with_related_view(relatedWebView)
		else:
			webView = WebKit2.WebView.new()
	webView.connect("destroy",unrefWebView)
	return webView

def init():
	global event
	event = module.require("event.py")

def start():
	url = None
	if len(sys.argv) > 1: url = sys.argv[1]
	windows.append(module.require(mfp.p("window","browser.py")).create(url))
	Gtk.main()