import gi
gi.require_version("Gtk","3.0")
from gi.repository import Gdk
import cairo

eventHandler = mfp.Bunch()
defaultIcon = cairo.ImageSurface.create_from_png(mfp.require("config").find(mfp.p("addon","favicon","default.png")))
defaultIcon = Gdk.pixbuf_get_from_surface(defaultIcon,0,0,defaultIcon.get_width(),defaultIcon.get_height())

def onFavicon(webView,_):
	window = webView.get_toplevel()
	favicon = webView.get_favicon()
	
	if favicon == None:
		window.set_icon(defaultIcon)
		return
	
	favicon = Gdk.pixbuf_get_from_surface(favicon,0,0,favicon.get_width(),favicon.get_height())
	window.set_icon(favicon)

def onWebviewCreated(webView):
	onFavicon(webView,None)
	webView.props.web_context.set_favicon_database_directory(None)
	webView.connect("notify::favicon",onFavicon)
eventHandler["webview:created"] = onWebviewCreated