import gi
gi.require_version("WebKit2","4.0")
from gi.repository import WebKit2

browser = mfp.require("browser")
eventHandler = mfp.Bunch()

def decidePolicy(webView,decision,decisionType):
	if decisionType == WebKit2.PolicyDecisionType.NAVIGATION_ACTION:
		navAction = decision.get_navigation_action()
		button = navAction.get_mouse_button()
		if button != 2: return False
		create(webView,navAction)
		decision.ignore()
		return True
	return False

def create(webView,navigationAction):
	newWebView = browser.createWebView()
	browser.windows.append(browser.module.require(mfp.p("window","browser.py")).create(webViews=[newWebView]))
	newWebView.load_request(navigationAction.get_request())

def onWebviewCreated(webView):
	webView.connect("decide-policy",decidePolicy)
	webView.connect("create",create)
eventHandler["webview:created"] = onWebviewCreated