eventHandler = mfp.Bunch()
browser = mfp.require("browser")

def onTitleChanged(obj,_):
	window = obj.get_toplevel()
	if len(window.cWebViews) > 1:
		window.set_title("Multiple pages")
		return
	
	title = obj.get_title()
	if title == "": title = obj.get_uri()
	if title == "" or title == None:
		window.set_title(browser.name)
		return
	window.set_title(title + " - " + browser.name)

def onWebviewCreated(webView):
	onTitleChanged(webView,None)
	webView.connect("notify::title",onTitleChanged)
eventHandler["webview:created"] = onWebviewCreated